-- DROP DATABASE IF EXISTS bespoke_tailoring;
-- CREATE DATABASE bespoke_tailoring2;
-- "NOT NULL" default in "AUTO_INCREMENT PRIMARY KEY"

SHOW TABLES;
USE bespoke_tailoring2;
CREATE TABLE product(
-- id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
id INT UNSIGNED AUTO_INCREMENT PRIMARY KEY,
product_name VARCHAR(100) NOT NULL,
product_price DECIMAL(13,4) NOT NULL
);
CREATE TABLE customer(
id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
fname VARCHAR(50) NOT NULL,
lname VARCHAR(50) NOT NULL
);
CREATE TABLE invoice(
id INT UNSIGNED NOT NULL PRIMARY KEY AUTO_INCREMENT,
customer_id INT UNSIGNED NOT NULL,
invoice_datetime DATETIME NOT NULL,
total DECIMAL(13,4)
);
CREATE TABLE item(
id INT UNSIGNED NOT NULL PRIMARY KEY AUTO_INCREMENT,
invoice_id INT UNSIGNED NOT NULL,
product_id INT UNSIGNED NOT NULL,
quantity INT NOT NULL
);

-- CREATE TABLE tax(
-- id INT NOT NULL PRIMARY KEY AUTO_INCREMENT,
-- tax_name VARCHAR(100) NOT NULL,
-- commentary VARCHAR(500)
-- );
-- CREATE TABLE tax_rate(
-- tax_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
-- rate TINYINT UNSIGNED NOT NULL
-- );

--foreign key	
--CREATE TABLE invoice(
--id INT UNSIGNED NOT NULL PRIMARY KEY AUTO_INCREMENT,
--customer_id INT UNSIGNED NOT NULL,
--invoice_datetime DATETIME NOT NULL,
--total DECIMAL(13,4)
--customer_id INT NOT NULL,
--CONSTRAINT fk_invoice_customer FOREIGN KEY (customer_id) REFERENCES customer(id) ON UPDATE CASCADE ON DELETE CASCADE
--);



ALTER TABLE invoice ADD CONSTRAINT fk_invoice_customer FOREIGN KEY (customer_id) REFERENCES customer(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE item ADD CONSTRAINT fk_item_invoice FOREIGN KEY (invoice_id) REFERENCES invoice(id) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE item ADD CONSTRAINT fk_item_product FOREIGN KEY (product_id) REFERENCES product(id) ON DELETE CASCADE ON UPDATE CASCADE;

-- inserting values on tables
INSERT INTO customer (fname, lname) VALUE ('Adres', 'Villa'), ('Lionel', 'Messi'), ('Cristiano', 'Ronaldo'),
('Andrea', 'Fiallos'), ('Nicole', 'Kidman'), ('Emma', 'Stone');

INSERT INTO product (product_name, product_price) VALUES 
('SONY PLAYSTATION 4 SLIM 1TB BLK CONSOLE', 10990.4567),
('SONY PLAYSTATION DS4 (ANY COLOR) GAME CONTROLLER', 2990.1234),
('SONY PS CAMERA ACCESSORIES', 2990.6789),
('PS4-ACE COMBAT 7:SKIES UNKNOWN (R3) GAMES', 2599.3456),
('PS4-CALL OF DUTTY BLACK OPS 4(R3) GAMES', 3149.9854),
('PS4-GOD OF WAR 2018', 1099.6521),
('PS4-MARVEL\'S SPIDER-MAN', 1899.4267),
('PS4-MORTAL KOMBAT 11 (R3)', 2595.8428);

INSERT INTO invoice (customer_id, invoice_datetime)  VALUES (5, TIMESTAMP('2019-01-03 09:46:00')),
(2, TIMESTAMP('2019-01-15 08:22:00')), (4, TIMESTAMP('2019-01-24 13:35:00')),
(6, TIMESTAMP('2019-02-07 10:07:00')), (3, TIMESTAMP('2019-02-12 11:10:00')),
(1, TIMESTAMP('2019-03-11 14:40:00')), (5, TIMESTAMP('2019-03-19 10:47:00')),
(2, TIMESTAMP('2019-04-05 09:31:00')), (6, TIMESTAMP('2019-04-06 13:48:00')),
(3, TIMESTAMP('2019-05-08 15:29:00'));

INSERT INTO item (invoice_id, product_id, quantity) VALUES (21, 6, 3), (21, 1, 4), (21, 2, 6), (21, 3, 9),
(22, 5, 5), (22, 8, 14), (22, 7, 11), (22, 4, 2), (22, 1, 14), (23, 6, 5), (23, 7, 11), (23, 2, 7),
(24, 8, 18), (24, 5, 5), (24, 1, 16), (24, 2, 8), (24, 7, 4), (25, 5, 8), (25, 1, 17), (25, 2, 6),
(26, 1, 4), (26, 2, 7), (26, 5, 7), (27, 1, 3), (27, 2, 11), (27, 3, 7), (27, 4, 12), (27, 6, 2),
(28, 1, 5), (28, 2, 4), (28, 6, 7), (29, 1, 3), (29, 2, 8), (29, 3, 7), (29, 5, 14), (30, 1, 7),
(30, 2, 18), (30, 3, 2), (30, 4, 16), (30, 5, 7);

